<template>
    <div class="main-container">
        <div class="hero margin-bottom-md font-bebas">
            <span>
                <h1>TRY OUR DELICIOUS</h1>
                <h1>PANCIT</h1>
            </span>
            <p>We are offering a door to door delivery around Quezon city</p>

            <el-button class="order-now margin-top-sm" size="large" @click="router.push('/login')"
                >Order now!</el-button
            >
        </div>
        <el-carousel
            class="opening_carousel"
            :interval="2000"
            :type="carouselType"
            indicator-position="outside"
        >
            <el-carousel-item v-for="item in carouselItems" :key="item">
                <img class="carousel_imgs" :src="`imgs/carousel/${item}.jpg`" />
            </el-carousel-item>
        </el-carousel>

        <div class="hero margin-top-lg margin-bottom-md font-bebas">
            <span>
                <h1>MENU</h1>
            </span>
            <p>Wallet-friendly foods that will leave you craving for more!</p>
        </div>

        <el-carousel
            indicator-position="outside"
            :height="menuCarouselHeight"
            :type="carouselType"
            :autoplay="false"
        >
            <el-carousel-item v-for="item in menuItems" :key="item">
                <img
                    class="carousel_imgs"
                    :src="`imgs/menu_carousel/${item}.jpg`"
                />
            </el-carousel-item>
        </el-carousel>

        <div class="hero margin-top-lg margin-bottom-md font-bebas">
            <span>
                <h1>ORDERING OPTIONS</h1>
            </span>
            <p>
                You can visit us in 17-21 Kagawad Rd, Quezon City, Metro Manila
            </p>

            <div class="margin-top-md flex items-justify">
                <div class="mapouter">
                    <div class="gmap_canvas">
                        <iframe
                            class="gmap_iframe"
                            frameborder="0"
                            scrolling="no"
                            marginheight="0"
                            marginwidth="0"
                            src="https://maps.google.com/maps?width=600&amp;height=400&amp;hl=en&amp;q=17-21 Kagawad Rd, Quezon City, Metro Manila&amp;t=&amp;z=14&amp;ie=UTF8&amp;iwloc=B&amp;output=embed"
                        ></iframe>
                    </div>
                </div>
            </div>
        </div>

        <div class="hero margin-top-lg margin-bottom-md font-bebas">
            <span>
                <h1>OR YOU CAN ORDER ONLINE!</h1>
            </span>
            <p>
                Click here to register and verify your account inorder to use
                our ordering system.
            </p>
            <el-button class="order-now margin-top-sm" size="large"
                >Order now!</el-button
            >
        </div>

        <div class="hero margin-top-lg margin-bottom-md font-bebas">
            <span>
                <h1>CUSTOMER REVIEWS</h1>
            </span>
            <p>
                Click here to register and verify your account inorder to use
                our ordering system.
            </p>
        </div>
            <el-carousel
            class="opening_carousel"
            :interval="7000"
            :type="carouselType"
            indicator-position="outside"
        >
            <el-carousel-item v-for="item in reviewItems" :key="item">
                <el-card class="padding-md review-card">
                    <img class="carousel_imgs" :src="`imgs/review_carousel/${item}.png`" />
                </el-card>
            </el-carousel-item>
        </el-carousel> 


        <el-footer>Footer</el-footer>
    </div>
</template>

<style lang="scss" scoped>
@import "../../../sass/app.scss";
.review-card{
    border-top-left-radius: 3rem;
    border-top-right-radius: 3rem;
    border-collapse: collapse;
}

.review_image{
    width:500px;
    height:auto;
}
.main-container {
    padding: 2rem;
}
.order-now {
    background-color: var(--el-color-primary);
    color: black;
    padding: 1.5rem;
    font-weight: bold;
    transition: background-color 0.3s;
}
.order-now:hover {
    background-color: var(--el-color-primary-light-9);
    color: var(--el-color-primary);
}

.hero span {
    display: flex;
    flex-wrap: wrap;
}

.hero h1 {
    font-size: 80px;
    margin: 0;
    color: white;
    text-shadow: 1px 2px 1px black;
}

.hero h1:nth-child(2) {
    margin-left: 1rem;
    color: var(--el-color-primary);
}

.hero p {
    font-size: 2rem;
    margin: 0;
}

.carousel_imgs {
    object-fit: contain;
    width: 100%;
    height: 100%;
}

.el-carousel__item h3 {
    color: #475669;
    opacity: 0.75;
    line-height: 200px;
    margin: 0;
    text-align: center;
}


@media (max-width: 768px) {
    .carousel-img {
        object-fit: cover;
        width: 100%;
        height: 100%;
        margin: 10%;
    }
}

.mapouter {
    position: relative;
    text-align: right;
    width: 100%;
    height: 400px;
    display: flex;
    justify-content: center;
}
.gmap_canvas {
    overflow: hidden;
    background: none !important;
    width: 600px;
    height: 400px;
}
.gmap_iframe {
    width: 600px !important;
    height: 400px !important;
}
</style>
<script setup>
import { ref, onMounted, onBeforeUnmount } from "vue";
import {useRouter} from "vue-router"

const router = useRouter();
const carouselItems = ref(["a", "b", "c", "d"]);

const menuItems = ref(["menu_a", "menu_b", "menu_c", "menu_d"]);

const reviewItems = ref(["review_a", "review_b", "review_c"])

const fisrtCarouselHeight = ref("500px");
const menuCarouselHeight = ref("700px");

const mediaQuery = window.matchMedia("(max-width: 768px)");
const carouselType = ref("slide");

const handleViewportChange = (mq) => {
    if (mq.matches) {
        carouselType.value = "slide";
        fisrtCarouselHeight.value = "300px";
        menuCarouselHeight.value = "400px";
    } else {
        carouselType.value = "card";
        fisrtCarouselHeight.value = "500px";
        menuCarouselHeight.value = "700px";
    }
};

onMounted ( () => {
    handleViewportChange(mediaQuery); 
    mediaQuery.addEventListener("change", handleViewportChange, { passive: true });
});

onBeforeUnmount( () => {
    handleViewportChange(mediaQuery); 
    mediaQuery.removeEventListener("change", handleViewportChange);
})

</script>
